Loading...
Searching...
No Matches
pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT > Class Template Reference
Module registration

Pose estimation and alignment class using a prerejective RANSAC routine. More...

`#include <pcl/registration/sample_consensus_prerejective.h>`

Inheritance diagram for pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >:

## Public Types

using | Matrix4 = typename Registration<PointSource, PointTarget>::Matrix4
using | PointCloudSource
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr
using | FeatureCloud = pcl::PointCloud<FeatureT>
using | FeatureCloudPtr = typename FeatureCloud::Ptr
using | FeatureCloudConstPtr = typename FeatureCloud::ConstPtr
using | Ptr
using | ConstPtr
using | FeatureKdTreePtr = typename KdTreeFLANN<FeatureT>::Ptr
using | CorrespondenceRejectorPoly
using | CorrespondenceRejectorPolyPtr = typename CorrespondenceRejectorPoly::Ptr
using | CorrespondenceRejectorPolyConstPtr
Public Types inherited from pcl::Registration< PointSource, PointTarget, Scalar >
using | Matrix4 = Eigen::Matrix<Scalar, 4, 4>
using | Ptr = shared_ptr<Registration<PointSource, PointTarget, Scalar>>
using | ConstPtr = shared_ptr<const Registration<PointSource, PointTarget, Scalar>>
using | CorrespondenceRejectorPtr = pcl::registration::CorrespondenceRejector::Ptr
using | KdTree = pcl::search::KdTree<PointTarget>
using | KdTreePtr = typename KdTree::Ptr
using | KdTreeReciprocal = pcl::search::KdTree<PointSource>
using | KdTreeReciprocalPtr = typename KdTreeReciprocal::Ptr
using | PointCloudSource = pcl::PointCloud<PointSource>
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget = pcl::PointCloud<PointTarget>
using | PointCloudTargetPtr = typename PointCloudTarget::Ptr
using | PointCloudTargetConstPtr = typename PointCloudTarget::ConstPtr
using | PointRepresentationConstPtr = typename KdTree::PointRepresentationConstPtr
using | TransformationEstimation
using | TransformationEstimationPtr = typename TransformationEstimation::Ptr
using | TransformationEstimationConstPtr = typename TransformationEstimation::ConstPtr
using | CorrespondenceEstimation
using | CorrespondenceEstimationPtr = typename CorrespondenceEstimation::Ptr
using | CorrespondenceEstimationConstPtr = typename CorrespondenceEstimation::ConstPtr
using | UpdateVisualizerCallbackSignature
| The callback signature to the function updating intermediate source point cloud position during it's registration to the target point cloud.
Public Types inherited from pcl::PCLBase< PointSource >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| SampleConsensusPrerejective ()
| Constructor.
| ~SampleConsensusPrerejective () override=default
| Destructor.
void | setSourceFeatures (const FeatureCloudConstPtr &features)
| Provide a boost shared pointer to the source point cloud's feature descriptors.
const FeatureCloudConstPtr | getSourceFeatures () const
| Get a pointer to the source point cloud's features.
void | setTargetFeatures (const FeatureCloudConstPtr &features)
| Provide a boost shared pointer to the target point cloud's feature descriptors.
const FeatureCloudConstPtr | getTargetFeatures () const
| Get a pointer to the target point cloud's features.
void | setNumberOfSamples (int nr_samples)
| Set the number of samples to use during each iteration.
int | getNumberOfSamples () const
| Get the number of samples to use during each iteration, as set by the user.
void | setCorrespondenceRandomness (int k)
| Set the number of neighbors to use when selecting a random feature correspondence.
int | getCorrespondenceRandomness () const
| Get the number of neighbors used when selecting a random feature correspondence, as set by the user.
void | setSimilarityThreshold (float similarity_threshold)
| Set the similarity threshold in [0,1[ between edge lengths of the underlying polygonal correspondence rejector object, where 1 is a perfect match.
float | getSimilarityThreshold () const
| Get the similarity threshold between edge lengths of the underlying polygonal correspondence rejector object,.
void | setInlierFraction (float inlier_fraction)
| Set the required inlier fraction (of the input).
float | getInlierFraction () const
| Get the required inlier fraction.
const pcl::Indices & | getInliers () const
| Get the inlier indices of the source point cloud under the final transformation.
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
| Registration ()
| Empty constructor.
| ~Registration () override=default
| destructor.
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object.
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object.
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target).
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target.
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to).
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target.
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud.
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud.
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding).
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud.
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method.
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method.
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for.
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user.
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for.
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user.
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop.
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user.
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target.
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target.
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) as set by the user.
void | setTransformationRotationEpsilon (double epsilon)
| Set the transformation rotation epsilon (maximum allowable rotation difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationRotationEpsilon ()
| Get the transformation rotation epsilon (maximum allowable difference between two consecutive transformations) as set by the user (epsilon is the cos(angle) in a axis-angle representation).
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user.
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points.
bool | registerVisualizationCallback (std::function< UpdateVisualizerCallbackSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration.
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target).
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points).
bool | hasConverged () const
| Return the state of convergence after the last align run.
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
const std::string & | getClassName () const
| Abstract class get name method.
bool | initCompute ()
| Internal computation initialization.
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed.
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list.
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors.
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list.
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors.
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
const PointSource & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

int | getRandomIndex (int n) const
| Choose a random index between 0 and n-1.
void | selectSamples (const PointCloudSource &cloud, int nr_samples, pcl::Indices &sample_indices)
| Select nr_samples sample points from cloud while making sure that their pairwise distances are greater than a user-defined minimum distance, min_sample_distance.
void | findSimilarFeatures (const pcl::Indices &sample_indices, std::vector< pcl::Indices > &similar_features, pcl::Indices &corresponding_indices)
| For each of the sample points, find a list of points in the target cloud whose features are similar to the sample points' features.
void | computeTransformation (PointCloudSource &output, const Eigen::Matrix4f &guess) override
| Rigid transformation computation method.
void | getFitness (pcl::Indices &inliers, float &fitness_score)
| Obtain the fitness of a transformation The following metrics are calculated, based on final_transformation_ and corr_dist_threshold_:
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, pcl::Indices &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point.
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess.
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

FeatureCloudConstPtr | input_features_
| The source point cloud's feature descriptors.
FeatureCloudConstPtr | target_features_
| The target point cloud's feature descriptors.
int | nr_samples_ {3}
| The number of samples to use during each iteration.
int | k_correspondences_ {2}
| The number of neighbors to use when selecting a random feature correspondence.
FeatureKdTreePtr | feature_tree_
| The KdTree used to compare feature descriptors.
CorrespondenceRejectorPolyPtr | correspondence_rejector_poly_
| The polygonal correspondence rejector used for prerejection.
float | inlier_fraction_ {0.0f}
| The fraction [0,1] of inlier points required for accepting a transformation.
pcl::Indices | inliers_
| Inlier points of final transformation as indices into source.
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, Scalar >
std::string | reg_name_
| The registration method name.
KdTreePtr | tree_
| A pointer to the spatial search object.
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source.
int | nr_iterations_ {0}
| The number of iterations the internal optimization ran for (used internally).
int | max_iterations_ {10}
| The maximum number of iterations the internal optimization should run for.
int | ransac_iterations_ {0}
| The number of iterations RANSAC should run for.
PointCloudTargetConstPtr | target_
| The input point cloud dataset target.
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations.
Matrix4 | transformation_
| The transformation matrix estimated by the registration method.
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally).
double | transformation_epsilon_ {0.0}
| The maximum difference between two consecutive transformations in order to consider convergence (user defined).
double | transformation_rotation_epsilon_ {0.0}
| The maximum rotation difference between two consecutive transformations in order to consider convergence (user defined).
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target.
double | inlier_threshold_ {0.05}
| The inlier distance threshold for the internal RANSAC outlier rejection loop.
bool | converged_ {false}
| Holds internal convergence state, given user parameters.
unsigned int | min_number_correspondences_ {3}
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation.
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step.
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation.
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud.
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use.
bool | target_cloud_updated_ {true}
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again.
bool | source_cloud_updated_ {true}
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again.
bool | force_no_recompute_ {false}
| A flag which, if set, means the tree operating on the target cloud will never be recomputed.
bool | force_no_recompute_reciprocal_ {false}
| A flag which, if set, means the tree operating on the source cloud will never be recomputed.
std::function< UpdateVisualizerCallbackSignature > | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud.
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointSource, typename PointTarget, typename FeatureT>
class pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >

Pose estimation and alignment class using a prerejective RANSAC routine.

This class inserts a simple, yet effective "prerejection" step into the standard RANSAC pose estimation loop in order to avoid verification of pose hypotheses that are likely to be wrong. This is achieved by local pose-invariant geometric constraints, as also implemented in the class CorrespondenceRejectorPoly.

In order to robustly align partial/occluded models, this routine performs fit error evaluation using only inliers, i.e. points closer than a Euclidean threshold, which is specifiable using setInlierFraction().

The amount of prerejection or "greedyness" of the algorithm can be specified using setSimilarityThreshold() in [0,1[, where a value of 0 means disabled, and 1 is maximally rejective.

If you use this in academic work, please cite:

A. G. Buch, D. Kraft, J.-K. Kämäräinen, H. G. Petersen and N. Krüger. Pose Estimation using Local Structure-Specific Shape and Appearance Context. International Conference on Robotics and Automation (ICRA), 2013.

Author
  Anders Glent Buch (ander.nosp@m.sgb1.nosp@m.@gmai.nosp@m.l.co.nosp@m.m)

Definition at line 75 of file sample_consensus_prerejective.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::ConstPtr

Initial value:
shared_ptr<const SampleConsensusPrerejective<PointSource, PointTarget, FeatureT>>

Definition at line 109 of file sample_consensus_prerejective.h.

## CorrespondenceRejectorPoly

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::CorrespondenceRejectorPoly

Initial value:
pcl::registration::CorrespondenceRejectorPoly<PointSource, PointTarget>
pcl::registration::CorrespondenceRejectorPoly
CorrespondenceRejectorPoly implements a correspondence rejection method that exploits low-level and p...
Definition correspondence_rejection_poly.h:63

Definition at line 114 of file sample_consensus_prerejective.h.

## CorrespondenceRejectorPolyConstPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::CorrespondenceRejectorPolyConstPtr

Initial value:
typename CorrespondenceRejectorPoly::ConstPtr
pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget >::ConstPtr
shared_ptr< const CorrespondenceRejectorPoly< PointSource, PointTarget > > ConstPtr
Definition correspondence_rejection_poly.h:70

Definition at line 117 of file sample_consensus_prerejective.h.

## CorrespondenceRejectorPolyPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::CorrespondenceRejectorPolyPtr = typename CorrespondenceRejectorPoly::Ptr

Definition at line 116 of file sample_consensus_prerejective.h.

## FeatureCloud

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureCloud = pcl::PointCloud<FeatureT>

Definition at line 103 of file sample_consensus_prerejective.h.

## FeatureCloudConstPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureCloudConstPtr = typename FeatureCloud::ConstPtr

Definition at line 105 of file sample_consensus_prerejective.h.

## FeatureCloudPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureCloudPtr = typename FeatureCloud::Ptr

Definition at line 104 of file sample_consensus_prerejective.h.

## FeatureKdTreePtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureKdTreePtr = typename KdTreeFLANN<FeatureT>::Ptr

Definition at line 112 of file sample_consensus_prerejective.h.

## Matrix4

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::Matrix4 = typename Registration<PointSource, PointTarget>::Matrix4

Definition at line 77 of file sample_consensus_prerejective.h.

## PointCloudSource

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudSource

Initial value:
typename Registration<PointSource, PointTarget>::PointCloudSource
pcl::Registration::PointCloudSource
pcl::PointCloud< PointSource > PointCloudSource
Definition registration.h:76

Definition at line 92 of file sample_consensus_prerejective.h.

## PointCloudSourceConstPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr

Definition at line 95 of file sample_consensus_prerejective.h.

## PointCloudSourcePtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudSourcePtr = typename PointCloudSource::Ptr

Definition at line 94 of file sample_consensus_prerejective.h.

## PointCloudTarget

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudTarget

Initial value:
typename Registration<PointSource, PointTarget>::PointCloudTarget
pcl::Registration::PointCloudTarget
pcl::PointCloud< PointTarget > PointCloudTarget
Definition registration.h:80

Definition at line 97 of file sample_consensus_prerejective.h.

## PointIndicesConstPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointIndicesConstPtr = PointIndices::ConstPtr

Definition at line 101 of file sample_consensus_prerejective.h.

## PointIndicesPtr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointIndicesPtr = PointIndices::Ptr

Definition at line 100 of file sample_consensus_prerejective.h.

## Ptr

template<typename PointSource, typename PointTarget, typename FeatureT>

using pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::Ptr

Initial value:
shared_ptr<SampleConsensusPrerejective<PointSource, PointTarget, FeatureT>>

Definition at line 107 of file sample_consensus_prerejective.h.

## Constructor & Destructor Documentation

## SampleConsensusPrerejective()

template<typename PointSource, typename PointTarget, typename FeatureT>

pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::SampleConsensusPrerejective | ( |  | ) |

inline

Constructor.

Definition at line 121 of file sample_consensus_prerejective.h.

References correspondence_rejector_poly_, feature_tree_, input_features_, pcl::Registration< PointSource, PointTarget, Scalar >::max_iterations_, pcl::Registration< PointSource, PointTarget, Scalar >::reg_name_, target_features_, and pcl::Registration< PointSource, PointTarget, Scalar >::transformation_estimation_.

## ~SampleConsensusPrerejective()

template<typename PointSource, typename PointTarget, typename FeatureT>

pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::~SampleConsensusPrerejective | ( |  | ) |

override default

Destructor.

## Member Function Documentation

## computeTransformation()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::computeTransformation | ( | PointCloudSource & | output,
|  | const Eigen::Matrix4f & | guess )

override protected

Rigid transformation computation method.

Parameters

  output | the transformed input point cloud dataset using the rigid transformation found
  guess | The computed transformation

Definition at line 154 of file sample_consensus_prerejective.hpp.

References pcl::Registration< PointSource, PointTarget, Scalar >::converged_, correspondence_rejector_poly_, pcl::Registration< PointSource, PointTarget, Scalar >::final_transformation_, findSimilarFeatures(), pcl::Registration< PointSource, PointTarget, Scalar >::getClassName(), getFitness(), inlier_fraction_, inliers_, pcl::PCLBase< PointSource >::input_, input_features_, k_correspondences_, pcl::Registration< PointSource, PointTarget, Scalar >::max_iterations_, nr_samples_, selectSamples(), pcl::Registration< PointSource, PointTarget, Scalar >::target_, target_features_, pcl::Registration< PointSource, PointTarget, Scalar >::transformation_, pcl::Registration< PointSource, PointTarget, Scalar >::transformation_estimation_, and pcl::transformPointCloud().

## findSimilarFeatures()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::findSimilarFeatures | ( | const pcl::Indices & | sample_indices,
|  | std::vector< pcl::Indices > & | similar_features,
|  | pcl::Indices & | corresponding_indices )

protected

For each of the sample points, find a list of points in the target cloud whose features are similar to the sample points' features.

From these, select one randomly which will be considered that sample point's correspondence.

Parameters

  sample_indices | the indices of each sample point
  similar_features | correspondence cache, which is used to read/write already computed correspondences
  corresponding_indices | the resulting indices of each sample's corresponding point in the target cloud

Definition at line 120 of file sample_consensus_prerejective.hpp.

References feature_tree_, getRandomIndex(), input_features_, and k_correspondences_.

Referenced by computeTransformation().

## getCorrespondenceRandomness()

template<typename PointSource, typename PointTarget, typename FeatureT>

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getCorrespondenceRandomness | ( |  | ) | const

inline

Get the number of neighbors used when selecting a random feature correspondence, as set by the user.

Definition at line 194 of file sample_consensus_prerejective.h.

References k_correspondences_.

## getFitness()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getFitness | ( | pcl::Indices & | inliers,
|  | float & | fitness_score )

protected

Obtain the fitness of a transformation The following metrics are calculated, based on final_transformation_ and corr_dist_threshold_:

- Inliers: the number of transformed points which are closer than threshold to NN
- Error score: the MSE of the inliers
  Parameters

    inliers | indices of source point cloud inliers
    fitness_score | output fitness score as RMSE

Definition at line 307 of file sample_consensus_prerejective.hpp.

References pcl::Registration< PointSource, PointTarget, Scalar >::corr_dist_threshold_, pcl::Registration< PointSource, PointTarget, Scalar >::final_transformation_, pcl::PCLBase< PointSource >::input_, pcl::transformPointCloud(), and pcl::Registration< PointSource, PointTarget, Scalar >::tree_.

Referenced by computeTransformation().

## getInlierFraction()

template<typename PointSource, typename PointTarget, typename FeatureT>

float pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getInlierFraction | ( |  | ) | const

inline

Get the required inlier fraction.

Returns
  required inlier fraction in [0,1]

Definition at line 231 of file sample_consensus_prerejective.h.

References inlier_fraction_.

## getInliers()

template<typename PointSource, typename PointTarget, typename FeatureT>

const pcl::Indices & pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getInliers | ( |  | ) | const

inline

Get the inlier indices of the source point cloud under the final transformation.

Returns
  inlier indices

Definition at line 241 of file sample_consensus_prerejective.h.

References inliers_.

## getNumberOfSamples()

template<typename PointSource, typename PointTarget, typename FeatureT>

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getNumberOfSamples | ( |  | ) | const

inline

Get the number of samples to use during each iteration, as set by the user.

Definition at line 175 of file sample_consensus_prerejective.h.

References nr_samples_.

## getRandomIndex()

template<typename PointSource, typename PointTarget, typename FeatureT>

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getRandomIndex | ( | int | n | ) | const

inline protected

Choose a random index between 0 and n-1.

Parameters

  n | the number of possible indices to choose from

Definition at line 251 of file sample_consensus_prerejective.h.

Referenced by findSimilarFeatures(), and selectSamples().

## getSimilarityThreshold()

template<typename PointSource, typename PointTarget, typename FeatureT>

float pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getSimilarityThreshold | ( |  | ) | const

inline

Get the similarity threshold between edge lengths of the underlying polygonal correspondence rejector object,.

Returns
  edge length similarity threshold

Definition at line 213 of file sample_consensus_prerejective.h.

References correspondence_rejector_poly_.

## getSourceFeatures()

template<typename PointSource, typename PointTarget, typename FeatureT>

const FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getSourceFeatures | ( |  | ) | const

inline

Get a pointer to the source point cloud's features.

Definition at line 145 of file sample_consensus_prerejective.h.

References input_features_.

## getTargetFeatures()

template<typename PointSource, typename PointTarget, typename FeatureT>

const FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getTargetFeatures | ( |  | ) | const

inline

Get a pointer to the target point cloud's features.

Definition at line 158 of file sample_consensus_prerejective.h.

References target_features_.

## selectSamples()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::selectSamples | ( | const PointCloudSource & | cloud,
|  | int | nr_samples,
|  | pcl::Indices & | sample_indices )

protected

Select nr_samples sample points from cloud while making sure that their pairwise distances are greater than a user-defined minimum distance, min_sample_distance.

Parameters

  cloud | the input point cloud
  nr_samples | the number of samples to select
  sample_indices | the resulting sample indices

Definition at line 77 of file sample_consensus_prerejective.hpp.

References pcl::Registration< PointSource, PointTarget, Scalar >::getClassName(), and getRandomIndex().

Referenced by computeTransformation().

## setCorrespondenceRandomness()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setCorrespondenceRandomness | ( | int | k | ) |

inline

Set the number of neighbors to use when selecting a random feature correspondence.

A higher value will add more randomness to the feature matching.

Parameters

  k | the number of neighbors to use when selecting a random feature correspondence.

Definition at line 186 of file sample_consensus_prerejective.h.

References k_correspondences_.

## setInlierFraction()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setInlierFraction | ( | float | inlier_fraction | ) |

inline

Set the required inlier fraction (of the input).

Parameters

  inlier_fraction | required inlier fraction, must be in [0,1]

Definition at line 222 of file sample_consensus_prerejective.h.

References inlier_fraction_.

## setNumberOfSamples()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setNumberOfSamples | ( | int | nr_samples | ) |

inline

Set the number of samples to use during each iteration.

Parameters

  nr_samples | the number of samples to use during each iteration

Definition at line 167 of file sample_consensus_prerejective.h.

References nr_samples_.

## setSimilarityThreshold()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setSimilarityThreshold | ( | float | similarity_threshold | ) |

inline

Set the similarity threshold in [0,1[ between edge lengths of the underlying polygonal correspondence rejector object, where 1 is a perfect match.

Parameters

  similarity_threshold | edge length similarity threshold

Definition at line 204 of file sample_consensus_prerejective.h.

References correspondence_rejector_poly_.

## setSourceFeatures()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setSourceFeatures | ( | const FeatureCloudConstPtr & | features | ) |

Provide a boost shared pointer to the source point cloud's feature descriptors.

Parameters

  features | the source point cloud's features

Definition at line 48 of file sample_consensus_prerejective.hpp.

References pcl::Registration< PointSource, PointTarget, Scalar >::getClassName(), and input_features_.

## setTargetFeatures()

template<typename PointSource, typename PointTarget, typename FeatureT>

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setTargetFeatures | ( | const FeatureCloudConstPtr & | features | ) |

Provide a boost shared pointer to the target point cloud's feature descriptors.

Parameters

  features | the target point cloud's features

Definition at line 62 of file sample_consensus_prerejective.hpp.

References feature_tree_, pcl::Registration< PointSource, PointTarget, Scalar >::getClassName(), and target_features_.

## Member Data Documentation

## correspondence_rejector_poly_

template<typename PointSource, typename PointTarget, typename FeatureT>

CorrespondenceRejectorPolyPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::correspondence_rejector_poly_

protected

The polygonal correspondence rejector used for prerejection.

Definition at line 315 of file sample_consensus_prerejective.h.

Referenced by computeTransformation(), getSimilarityThreshold(), SampleConsensusPrerejective(), and setSimilarityThreshold().

## feature_tree_

template<typename PointSource, typename PointTarget, typename FeatureT>

FeatureKdTreePtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::feature_tree_

protected

The KdTree used to compare feature descriptors.

Definition at line 312 of file sample_consensus_prerejective.h.

Referenced by findSimilarFeatures(), SampleConsensusPrerejective(), and setTargetFeatures().

## inlier_fraction_

template<typename PointSource, typename PointTarget, typename FeatureT>

float pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::inlier_fraction_ {0.0f}

protected

The fraction [0,1] of inlier points required for accepting a transformation.

Definition at line 319 of file sample_consensus_prerejective.h.

Referenced by computeTransformation(), getInlierFraction(), and setInlierFraction().

## inliers_

template<typename PointSource, typename PointTarget, typename FeatureT>

pcl::Indices pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::inliers_

protected

Inlier points of final transformation as indices into source.

Definition at line 322 of file sample_consensus_prerejective.h.

Referenced by computeTransformation(), and getInliers().

## input_features_

template<typename PointSource, typename PointTarget, typename FeatureT>

FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::input_features_

protected

The source point cloud's feature descriptors.

Definition at line 299 of file sample_consensus_prerejective.h.

Referenced by computeTransformation(), findSimilarFeatures(), getSourceFeatures(), SampleConsensusPrerejective(), and setSourceFeatures().

## k_correspondences_

template<typename PointSource, typename PointTarget, typename FeatureT>

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::k_correspondences_ {2}

protected

The number of neighbors to use when selecting a random feature correspondence.

Definition at line 309 of file sample_consensus_prerejective.h.

Referenced by computeTransformation(), findSimilarFeatures(), getCorrespondenceRandomness(), and setCorrespondenceRandomness().

## nr_samples_

template<typename PointSource, typename PointTarget, typename FeatureT>

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::nr_samples_ {3}

protected

The number of samples to use during each iteration.

Definition at line 305 of file sample_consensus_prerejective.h.

Referenced by computeTransformation(), getNumberOfSamples(), and setNumberOfSamples().

## target_features_

template<typename PointSource, typename PointTarget, typename FeatureT>

FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::target_features_

protected

The target point cloud's feature descriptors.

Definition at line 302 of file sample_consensus_prerejective.h.

Referenced by computeTransformation(), getTargetFeatures(), SampleConsensusPrerejective(), and setTargetFeatures().

The documentation for this class was generated from the following files:

- pcl/registration/sample_consensus_prerejective.h
- pcl/registration/impl/sample_consensus_prerejective.hpp